/*******************************************************************************
 * Copyright (c) 2011, 2012 SINTEF, Martin F. Johansen.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     SINTEF, Martin F. Johansen - the implementation
 *******************************************************************************/

import java.io.File;
import java.io.IOException;
import java.util.Collections;
import java.util.Map;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;

import cvl.CVLModel;
import cvl.CvlPackage;


public class CVLUtils {
	public static CVLModel loadCVLModel(File cvlFile) {
		Resource.Factory.Registry reg = Resource.Factory.Registry.INSTANCE;
		Map<String, Object> m = reg.getExtensionToFactoryMap();
		m.put("cvl", new XMIResourceFactoryImpl());
		EPackage.Registry.INSTANCE.put(CvlPackage.eNS_URI, CvlPackage.eINSTANCE);
		ResourceSet resSet=new ResourceSetImpl();
		Resource res = resSet.getResource(URI.createURI(cvlFile.toURI().toString()),true);

		return (CVLModel)res.getContents().get(0);
	}
	
	public static void saveCVLModel(CVLModel cvlModel, File cvlFile){
		URI fileURI = URI.createURI(cvlFile.toURI().toString());
		Resource resource = new XMIResourceFactoryImpl().createResource(fileURI);
		resource.getContents().add(cvlModel);
		try{
			resource.save(Collections.EMPTY_MAP);
		}catch(IOException e){
			e.printStackTrace();
		}
	}
}
