/*******************************************************************************
 * Copyright (c) 2011, 2012 SINTEF, Martin F. Johansen.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     SINTEF, Martin F. Johansen - the implementation
 *******************************************************************************/

import static org.junit.Assert.assertEquals;

import java.io.File;
import java.io.IOException;
import java.util.List;

import no.sintef.ict.splcatool.CSVException;
import org.junit.Test;

import cvl.CVLModel;


public class TestCVL {
	@Test
	public void testInjectActual() throws IOException, CSVException, InterruptedException{
		for(File f : new File("TestData/Artificial/ACollection/").listFiles()){
			
			if(!f.getName().endsWith(".cvl")) continue;
			if(!f.getName().endsWith("SafetyModule.cvl")) continue;
			
			//System.out.println(f.getName());
			
			CVLModel x = CVLUtils.loadCVLModel(f);
			
			List<String> cs = CVL2GDSL.getConstraints(x.getVariabilitySpecification());

			assertEquals("(Limit_Values) implies (Level2)", cs.get(0));
			assertEquals("(not (Level2)) implies (Level3)", cs.get(1));
		}
	}
}
