/*******************************************************************************
 * Copyright (c) 2011, 2012 SINTEF, Martin F. Johansen.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     SINTEF, Martin F. Johansen - the implementation
 *******************************************************************************/

package no.sintef.ict.splcatool;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class XLSXLib {
	public static String getCSV(File file) throws IOException{
		String filename = file.getAbsoluteFile().toString();
		FileInputStream fis = new FileInputStream(filename);
            
        XSSFWorkbook workbook = new XSSFWorkbook(fis);
        XSSFSheet sheet = workbook.getSheetAt(0);
        
        String csv = "";
        for(int y = 0; y <= sheet.getLastRowNum(); y++){
            XSSFRow row = sheet.getRow(y);
            //int cs = 0;
            if(row == null){
            	csv += " ;";
            }else
            for(int x = 0; x <= row.getLastCellNum(); x++){
            	XSSFCell cell = row.getCell(x);
                String v = "";
                if(cell == null){
                	v = " ";
                }else if(cell.getCellType() == XSSFCell.CELL_TYPE_STRING){
                	v = cell.getStringCellValue();
                }else if(cell.getCellType() == XSSFCell.CELL_TYPE_NUMERIC){
                	v = ""+(int) cell.getNumericCellValue();
                }else if(cell.getCellType() == XSSFCell.CELL_TYPE_BLANK){
                	v = " ";
                }else{
                	System.out.println("Unknown type " + cell.getCellType() + " " + cell.getRawValue());
                	System.exit(-1);
                }
                csv += v + ";";
                //cs++;
            }
            //System.out.println(cs);
            csv += "\n";
        }
		
		return csv;
	}

}
