/*******************************************************************************
 * Copyright (c) 2011, 2012 SINTEF, Martin F. Johansen.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     SINTEF, Martin F. Johansen - the implementation
 *******************************************************************************/

package no.sintef.ict.splcatool.lasplt;
import java.io.IOException;


public class CSV {
	private int x, y;
	private String[][] csv;
	private String columns[]; 

	@Override
	public String toString() {
		String str = "";
		for(int j = 0; j < y; j++){
			for(int i = 0; i < x; i++){
				str += csv[j][i] + ";";
			}
			str += "\n";
		}
		return str;
	}
	
	public int getWidth(){
		return x;
	}
	
	public int getHeight(){
		return y-1;
	}

	public String getColumnName(int n){
		return columns[n];
	}
	
	public int getColumnNr(String name){
		for(int i = 0; i < columns.length; i++)
			if(columns[i].equals(name))
				return i;
		return -1;
	}
	
	public String getColumnEntry(String name, int i){
		int n = getColumnNr(name);
		return csv[i+1][n];
	}

	public CSV(String filename) throws IOException {
		// Read file
		String csvString = new FileUtility().readFileAsString(filename);
		csvString = csvString.replaceAll("\r", "\n");
		csvString = csvString.replaceAll("\n\n", "\n");
		
		// Load
		String rows [] = csvString.split("\n");
		x = rows[0].split(";").length;
		y = rows.length;

		csv = new String[y][x];
		for(int j = 0; j < y; j++){
			String row = rows[j];
			String elements [] = row.split(";");
//			System.out.println(row);
			for(int i = 0; i < x; i++){
				if(i < elements.length)
					csv[j][i] = elements[i].trim();
				else
					csv[j][i] = "";
			}
		}
		
		columns = csv[0];
	}

}
