/*******************************************************************************
 * Copyright (c) 2011, 2012 SINTEF, Martin F. Johansen.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     SINTEF, Martin F. Johansen - the implementation
 *******************************************************************************/

package no.sintef.ict.splcatool.lasplt;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.reflect.InvocationTargetException;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;

public class EclipseProduct extends Product {

	private List<String> configuration;
	private CSV testpackagescsv;
	private String baseEclipse;
	private String base;
	private String sevenZip;
	private String dir;
	private String testZip;
	private String testZipSite;
	private String id;

	public EclipseProduct(String id, String zip, String dir, String sevenZip, String base, String launcher, CSV packagescsv, CSV testpackagescsv, List<String> configuration, String testZip, String testZipSite) throws IOException, SecurityException, IllegalArgumentException, NoSuchMethodException, IllegalAccessException, InvocationTargetException, ClassNotFoundException {
		this.id = id;
		this.testpackagescsv = testpackagescsv;
		this.configuration = configuration;
		this.base = base;
		this.sevenZip = sevenZip;
		this.dir = dir;
		this.testZip = testZip;
		this.testZipSite = testZipSite;
		
		// Make dir
		File d = new File(dir);
		File b = new File(base);
		
		System.out.println("Product " + id + ": " + dir);
		
/*		if(!d.exists()){
			d.mkdir();
		
			String command = b.getAbsolutePath() + "\\packages\\" + sevenZip + " x" + " -o\"" + d.getAbsolutePath() + "\" " + (b.getAbsolutePath() + "\\packages\\" + zip + ".zip");
			System.out.println(command);
			
			// Unzip
		    try {
		        String line;
		        Process p = Runtime.getRuntime().exec(command);
		        BufferedReader input =
		          new BufferedReader
		            (new InputStreamReader(p.getInputStream()));
		        while ((line = input.readLine()) != null) {
		          System.out.println(line);
		        }
		        input.close();
		      }
		      catch (Exception err) {
		        err.printStackTrace();
		      }
		}
*/

		baseEclipse = d.getAbsolutePath() + "\\eclipse\\plugins\\" + launcher;
		//System.out.println(baseEclipse);

		// Install packages
/*		RunJar jr;
		for(int j = 0; j < configuration.size(); j++){
			String name = configuration.get(j);
			
			//System.out.println(name);
				
			for(int x = 0; x < packagescsv.getHeight(); x++){
				if(packagescsv.getColumnEntry("Feature", x).equals(name)){
					int rownr = x;
					if(!packagescsv.getColumnEntry("Component", rownr).equals("")){
						//System.out.print(name);
						String component = packagescsv.getColumnEntry("Component", rownr);
						String version = packagescsv.getColumnEntry("Version", rownr);
						String repository = packagescsv.getColumnEntry("Repository", rownr);
						//System.out.println("("+component + ", " + version + ", " + repository +")" + ", ");
						System.out.println("Installing "+component + ", " + version +"");
						
						jr = new RunJar(baseEclipse, new String[] {"-application", "org.eclipse.equinox.p2.director", "-repository", repository, "-installIU", component + "/" + version});
						jr.run();
					}
				}
			}
			
			//System.out.println(rownr);
			

		}
		System.out.println();
		*/
	}
	
	@Override
	public void prepareForTesting() throws SecurityException, IllegalArgumentException, NoSuchMethodException, IllegalAccessException, InvocationTargetException, ClassNotFoundException, IOException {
		// Copy tests
		File b = new File(base);
		String dest = b.getAbsolutePath() + "\\workspace\\" + testZip;
		if(!new File(dest).exists()){
			String command = b.getAbsolutePath() + "\\packages\\" + sevenZip + " x" + " -o\"" + dest + "\" " + (b.getAbsolutePath() + "\\packages\\" + testZip + ".zip");
			System.out.println(command);
		    new RunCommand(command, new String [] {}).run();
		}
		
		dest = b.getAbsolutePath() + "\\workspace\\" + testZipSite;
		if(!new File(dest).exists()){
			String command = b.getAbsolutePath() + "\\packages\\" + sevenZip + " x" + " -o\"" + dest + "\" " + (b.getAbsolutePath() + "\\packages\\" + testZip + "\\eclipse-testing\\" + testZipSite + ".zip");
			System.out.println(command);
			new RunCommand(command, new String [] {}).run();
		}
		
		for(int j = 0; j < configuration.size(); j++){
			String name = configuration.get(j);
			
			/*int rownr = -1;
			for(int x = 0; x < packagescsv.getHeight(); x++){
				if(packagescsv.getColumnEntry("Feature", x).equals(name)){
					rownr = x;
				}
			}*/
			
			for(int z = 0; z < testpackagescsv.getHeight(); z++){
				if(!testpackagescsv.getColumnEntry("Feature", z).equals(name)) continue;
				//System.out.print(name);
				String component = testpackagescsv.getColumnEntry("Test Component", z);
				String version = testpackagescsv.getColumnEntry("Test Version", z);
				String repository = testpackagescsv.getColumnEntry("Test Repository", z);
				//System.out.print("("+component + ", " + version + ", " + repository +")" + ", ");
				
				RunJar jr = new RunJar(baseEclipse, new String[] {"-application", "org.eclipse.equinox.p2.director", "-repository", repository, "-installIU", component + "/" + version});
				jr.run();
			}
		}
	}

	@Override
	public void runTests(Report r) throws FileNotFoundException, IOException, SecurityException, IllegalArgumentException, NoSuchMethodException, IllegalAccessException, InvocationTargetException, ClassNotFoundException {
		for(int j = 0; j < configuration.size(); j++){
			String name = configuration.get(j);
			
			/*int rownr = -1;
			for(int x = 0; x < packagescsv.getHeight(); x++){
				if(packagescsv.getColumnEntry("Feature", x).equals(name)){
					rownr = x;
				}
			}*/
			
			//System.out.println(name + ", " + rownr);
			
			for(int z = 0; z < testpackagescsv.getHeight(); z++){
				if(!testpackagescsv.getColumnEntry("Feature", z).equals(name)) continue;
				
				//System.out.print(name);
				String testClass = testpackagescsv.getColumnEntry("Test Class", z);
				String component = testpackagescsv.getColumnEntry("Test Component", z);
				String testapp = testpackagescsv.getColumnEntry("Test Application", z);
				//System.out.print("("+component + ", " + version + ", " + repository +")" + ", ");
				
				//if(!testClass.equals("org.eclipse.pde.build.tests.PDEBuildTestSuite")) continue;
				
				if(testClass.equals("")) continue; // Skip, it is only a support package
				
				// Clear workspace
				new File(dir + "/workspace").delete();
				
				// Execute Test
				System.out.println("Executing tests (" + id + "): " + testClass + " in " + component);
				RunJar jr = new RunJar(baseEclipse, new String[] {
					"-application", testapp, 
					"-os", "win32",
					"-ws", "win32",
					"-arch", "x86_64",
					"-dev", "bin",
					"-testpluginname", component,
					"-classname", testClass,
					"formatter=org.apache.tools.ant.taskdefs.optional.junit.XMLJUnitResultFormatter,"+testClass+"-test-result-product"+id+".xml",
					"-data", dir + "/workspace",
					"-consolelog"
				});
				jr.run();

				// Save results
				System.out.println("Results were: ");
				
				/* Load XML */
				if(new File(testClass+"-test-result-product"+id+".xml").exists()){
					DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
					DocumentBuilder db = null;
					try {
						db = dbf.newDocumentBuilder();
					} catch (ParserConfigurationException e) {
						// TODO Auto-generated catch block
						//e.printStackTrace();
						System.out.println("Error parsing (ParserConfigurationException) " + testClass+"-test-result-product"+id+".xml");
						continue;
					}
					Document dom = null;
					try {
						dom = db.parse(testClass+"-test-result-product"+id+".xml");
					} catch (SAXException e) {
						// TODO Auto-generated catch block
						//e.printStackTrace();
						System.out.println("Error parsing (SAXException) " + testClass+"-test-result-product"+id+".xml");
						continue;
					}
					
					Element docEle = dom.getDocumentElement();
					//NodeList nl = docEle.getElementsByTagName("testsuite");
					//Node item = nl.item(i).getAttributes().getNamedItem("tests");
					int tests = new Integer(docEle.getAttribute("tests"));
					int failures = new Integer(docEle.getAttribute("failures"));
					int errors = new Integer(docEle.getAttribute("errors"));
					String time = docEle.getAttribute("time");
					int success = tests - failures - errors;
					System.out.println("Tests: " + tests);
					System.out.println("success: " + success + ", " + Math.round(((double)success/tests*100)) + "%");
					System.out.println("failures: " + failures);
					System.out.println("errors: " + errors);
					System.out.println("time: " + time);
					System.out.println("timestamp: " + docEle.getAttribute("timestamp"));
					
					r.writeLine(id + ";" + name + ";" + testClass + ";" + tests + ";" + success + ";" + failures + ";" + errors + ";" + time + ";");
				}
			}
		}
	}
}
