/*******************************************************************************
 * Copyright (c) 2011, 2012 SINTEF, Martin F. Johansen.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     SINTEF, Martin F. Johansen - the implementation
 *******************************************************************************/

package no.sintef.ict.splcatool.lasplt;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.util.concurrent.TimeoutException;

import splar.core.fm.FeatureModelException;
import de.ovgu.featureide.fm.core.io.UnsupportedModelException;

public class NLTSPLT {

	public static void main(String[] args) throws IOException, UnsupportedModelException, FeatureModelException, TimeoutException, SecurityException, IllegalArgumentException, NoSuchMethodException, IllegalAccessException, InvocationTargetException, ClassNotFoundException {
		String packages = "packages.csv";
		String testpackages = "test-packages.csv";
		String featureModel = "Eclipse-red.m";
		
		// Load test script
		CSV packagescsv = new CSV(packages);
		CSV testpackagescsv = new CSV(testpackages);
		
		// Construct Product Line
		// Paths
		String home = "C://Users/mjoha/eclipsespl/new2/";
		String launcher = "org.eclipse.equinox.launcher_1.2.0.v20110502.jar";
		String zip = "eclipse-platform-3.7-win32-x86_64";
		String sevenZip = "7za";
		String testZip = "eclipse-Automated-Tests-3.7";
		String testZipSite = "eclipse-junit-tests-I20110613-1736";
		
		Report r = new Report("testReport.csv");
		r.writeLine("Product;Feature;TestClass;Tests;Success;Failure;Error;Time;");
		
		SoftwareProductLine spl = new SPLEclipseBased(featureModel, packagescsv, testpackagescsv, home, launcher, zip, sevenZip, testZip, testZipSite);
		spl.generateCoveringProducts(2);
		
		// Sequential, single threaded execution of tests
		for(int i = 0; i < spl.products(); i++){
			Product p = spl.getProduct(i);
			try {
				//p.prepareForTesting();
				p.runTests(r);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		
		// Threaded execution of tests
/*		List<Thread> lt = new ArrayList<Thread>();
		for(int i = 0; i < spl.products(); i++){
			Product p = spl.getProduct(i);
			TestThread tt = new TestThread(p, r);
			Thread t = new Thread(tt);
			t.run();
			lt.add(t);
		}
*/
	}

}
