/*******************************************************************************
 * Copyright (c) 2011, 2012 SINTEF, Martin F. Johansen.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     SINTEF, Martin F. Johansen - the implementation
 *******************************************************************************/

package no.sintef.ict.splcatool.lasplt;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.jar.Attributes;
import java.util.jar.JarFile;
import java.util.jar.Manifest;

public class RunCommand {

	private String command;
	private String[] args;

	public RunCommand(String command, String[] args) {
		this.command = command;
		this.args = args;
	}

	public void run() throws SecurityException, NoSuchMethodException, IllegalArgumentException, IllegalAccessException, InvocationTargetException, ClassNotFoundException, IOException {
		
		String oneArgs = "";
		for(String x : args)
			oneArgs += x + " ";
		
	    try {
	    	String line;
	    	Process p = Runtime.getRuntime().exec(command + " " + oneArgs);
	    	BufferedReader input = new BufferedReader(new InputStreamReader(p.getInputStream()));
	    	BufferedReader error = new BufferedReader(new InputStreamReader(p.getErrorStream()));
	    	while ((line = input.readLine()) != null) {
	    		System.out.println(line);
	    	}
	    	while ((line = error.readLine()) != null) {
	    		System.out.println(line);
	    	}
	    	input.close();
	    	error.close();
	    }catch (Exception err) {
	    	err.printStackTrace();
	    }
	      
	   // System.out.println("Done");
	}
}
