/*******************************************************************************
 * Copyright (c) 2011, 2012 SINTEF, Martin F. Johansen.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     SINTEF, Martin F. Johansen - the implementation
 *******************************************************************************/

package no.sintef.ict.splcatool.lasplt;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeoutException;

abstract public class SoftwareProductLine {
	protected List<Product> products = new ArrayList<Product>();
	
	public void addProduct(Product product){
		products.add(product);
	}
	
	public Product getProduct(int nr){
		return products.get(nr);
	}
	
	abstract public void generateCoveringProducts(int t) throws TimeoutException, IOException, SecurityException, IllegalArgumentException, NoSuchMethodException, IllegalAccessException, InvocationTargetException, ClassNotFoundException;

	public int products() {
		return products.size();
	}
}
