/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package cvl.provider;


import cvl.CVLModel;
import cvl.CvlFactory;
import cvl.CvlPackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link cvl.CVLModel} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class CVLModelItemProvider
	extends CVLNamedElementItemProvider
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CVLModelItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addBasePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Base feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addBasePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_CVLModel_base_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_CVLModel_base_feature", "_UI_CVLModel_type"),
				 CvlPackage.Literals.CVL_MODEL__BASE,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION);
			childrenFeatures.add(CvlPackage.Literals.CVL_MODEL__RESOLUTION_SPECIFICATION);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns CVLModel.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/CVLModel"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((CVLModel)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_CVLModel_type") :
			getString("_UI_CVLModel_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(CVLModel.class)) {
			case CvlPackage.CVL_MODEL__VARIABILITY_SPECIFICATION:
			case CvlPackage.CVL_MODEL__RESOLUTION_SPECIFICATION:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createReferenceSubstitution()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createValueSubstitution()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createFragmentSubstitution()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createPlacementFragment()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createReplacementFragment()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createCompositeVariability()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createPlacementValue()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createPlacementObject()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createReplacementValue()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createReplacementObject()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createType()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createInvocation()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createIterator()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createReplacementFragmentReference()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createAssignment()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createConstraint()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createNOT()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createOR()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createIMPLIES()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createExecutablePrimitiveTerm()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__VARIABILITY_SPECIFICATION,
				 CvlFactory.eINSTANCE.createAND_()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__RESOLUTION_SPECIFICATION,
				 CvlFactory.eINSTANCE.createResolutionElement()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__RESOLUTION_SPECIFICATION,
				 CvlFactory.eINSTANCE.createIteratorResolution()));

		newChildDescriptors.add
			(createChildParameter
				(CvlPackage.Literals.CVL_MODEL__RESOLUTION_SPECIFICATION,
				 CvlFactory.eINSTANCE.createResolutionValue()));
	}

}
