/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package cvl.provider;

import cvl.util.CvlAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class CvlItemProviderAdapterFactory extends CvlAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CvlItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.CVLModel} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CVLModelItemProvider cvlModelItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.CVLModel}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCVLModelAdapter() {
		if (cvlModelItemProvider == null) {
			cvlModelItemProvider = new CVLModelItemProvider(this);
		}

		return cvlModelItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.ReferenceSubstitution} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReferenceSubstitutionItemProvider referenceSubstitutionItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.ReferenceSubstitution}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createReferenceSubstitutionAdapter() {
		if (referenceSubstitutionItemProvider == null) {
			referenceSubstitutionItemProvider = new ReferenceSubstitutionItemProvider(this);
		}

		return referenceSubstitutionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.ValueSubstitution} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ValueSubstitutionItemProvider valueSubstitutionItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.ValueSubstitution}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createValueSubstitutionAdapter() {
		if (valueSubstitutionItemProvider == null) {
			valueSubstitutionItemProvider = new ValueSubstitutionItemProvider(this);
		}

		return valueSubstitutionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.FragmentSubstitution} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FragmentSubstitutionItemProvider fragmentSubstitutionItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.FragmentSubstitution}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFragmentSubstitutionAdapter() {
		if (fragmentSubstitutionItemProvider == null) {
			fragmentSubstitutionItemProvider = new FragmentSubstitutionItemProvider(this);
		}

		return fragmentSubstitutionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.PlacementFragment} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PlacementFragmentItemProvider placementFragmentItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.PlacementFragment}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPlacementFragmentAdapter() {
		if (placementFragmentItemProvider == null) {
			placementFragmentItemProvider = new PlacementFragmentItemProvider(this);
		}

		return placementFragmentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.ReplacementFragment} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReplacementFragmentItemProvider replacementFragmentItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.ReplacementFragment}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createReplacementFragmentAdapter() {
		if (replacementFragmentItemProvider == null) {
			replacementFragmentItemProvider = new ReplacementFragmentItemProvider(this);
		}

		return replacementFragmentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.FromPlacement} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FromPlacementItemProvider fromPlacementItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.FromPlacement}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFromPlacementAdapter() {
		if (fromPlacementItemProvider == null) {
			fromPlacementItemProvider = new FromPlacementItemProvider(this);
		}

		return fromPlacementItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.ToPlacement} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ToPlacementItemProvider toPlacementItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.ToPlacement}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createToPlacementAdapter() {
		if (toPlacementItemProvider == null) {
			toPlacementItemProvider = new ToPlacementItemProvider(this);
		}

		return toPlacementItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.ToReplacement} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ToReplacementItemProvider toReplacementItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.ToReplacement}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createToReplacementAdapter() {
		if (toReplacementItemProvider == null) {
			toReplacementItemProvider = new ToReplacementItemProvider(this);
		}

		return toReplacementItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.FromReplacement} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FromReplacementItemProvider fromReplacementItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.FromReplacement}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFromReplacementAdapter() {
		if (fromReplacementItemProvider == null) {
			fromReplacementItemProvider = new FromReplacementItemProvider(this);
		}

		return fromReplacementItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.CVLElement} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CVLElementItemProvider cvlElementItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.CVLElement}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCVLElementAdapter() {
		if (cvlElementItemProvider == null) {
			cvlElementItemProvider = new CVLElementItemProvider(this);
		}

		return cvlElementItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.ToBinding} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ToBindingItemProvider toBindingItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.ToBinding}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createToBindingAdapter() {
		if (toBindingItemProvider == null) {
			toBindingItemProvider = new ToBindingItemProvider(this);
		}

		return toBindingItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.FromBinding} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FromBindingItemProvider fromBindingItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.FromBinding}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFromBindingAdapter() {
		if (fromBindingItemProvider == null) {
			fromBindingItemProvider = new FromBindingItemProvider(this);
		}

		return fromBindingItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.CompositeVariability} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CompositeVariabilityItemProvider compositeVariabilityItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.CompositeVariability}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCompositeVariabilityAdapter() {
		if (compositeVariabilityItemProvider == null) {
			compositeVariabilityItemProvider = new CompositeVariabilityItemProvider(this);
		}

		return compositeVariabilityItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.PlacementValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PlacementValueItemProvider placementValueItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.PlacementValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPlacementValueAdapter() {
		if (placementValueItemProvider == null) {
			placementValueItemProvider = new PlacementValueItemProvider(this);
		}

		return placementValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.PlacementObject} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PlacementObjectItemProvider placementObjectItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.PlacementObject}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPlacementObjectAdapter() {
		if (placementObjectItemProvider == null) {
			placementObjectItemProvider = new PlacementObjectItemProvider(this);
		}

		return placementObjectItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.ReplacementValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReplacementValueItemProvider replacementValueItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.ReplacementValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createReplacementValueAdapter() {
		if (replacementValueItemProvider == null) {
			replacementValueItemProvider = new ReplacementValueItemProvider(this);
		}

		return replacementValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.ReplacementObject} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReplacementObjectItemProvider replacementObjectItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.ReplacementObject}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createReplacementObjectAdapter() {
		if (replacementObjectItemProvider == null) {
			replacementObjectItemProvider = new ReplacementObjectItemProvider(this);
		}

		return replacementObjectItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.ResolutionElement} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ResolutionElementItemProvider resolutionElementItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.ResolutionElement}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createResolutionElementAdapter() {
		if (resolutionElementItemProvider == null) {
			resolutionElementItemProvider = new ResolutionElementItemProvider(this);
		}

		return resolutionElementItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.Type} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TypeItemProvider typeItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.Type}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTypeAdapter() {
		if (typeItemProvider == null) {
			typeItemProvider = new TypeItemProvider(this);
		}

		return typeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.Invocation} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InvocationItemProvider invocationItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.Invocation}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInvocationAdapter() {
		if (invocationItemProvider == null) {
			invocationItemProvider = new InvocationItemProvider(this);
		}

		return invocationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.IteratorResolution} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IteratorResolutionItemProvider iteratorResolutionItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.IteratorResolution}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIteratorResolutionAdapter() {
		if (iteratorResolutionItemProvider == null) {
			iteratorResolutionItemProvider = new IteratorResolutionItemProvider(this);
		}

		return iteratorResolutionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.Iterator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IteratorItemProvider iteratorItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.Iterator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIteratorAdapter() {
		if (iteratorItemProvider == null) {
			iteratorItemProvider = new IteratorItemProvider(this);
		}

		return iteratorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.ReplacementFragmentReference} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReplacementFragmentReferenceItemProvider replacementFragmentReferenceItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.ReplacementFragmentReference}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createReplacementFragmentReferenceAdapter() {
		if (replacementFragmentReferenceItemProvider == null) {
			replacementFragmentReferenceItemProvider = new ReplacementFragmentReferenceItemProvider(this);
		}

		return replacementFragmentReferenceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.Assignment} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AssignmentItemProvider assignmentItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.Assignment}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAssignmentAdapter() {
		if (assignmentItemProvider == null) {
			assignmentItemProvider = new AssignmentItemProvider(this);
		}

		return assignmentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.Constraint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConstraintItemProvider constraintItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.Constraint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createConstraintAdapter() {
		if (constraintItemProvider == null) {
			constraintItemProvider = new ConstraintItemProvider(this);
		}

		return constraintItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.NOT} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NOTItemProvider notItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.NOT}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNOTAdapter() {
		if (notItemProvider == null) {
			notItemProvider = new NOTItemProvider(this);
		}

		return notItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.OR} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ORItemProvider orItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.OR}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createORAdapter() {
		if (orItemProvider == null) {
			orItemProvider = new ORItemProvider(this);
		}

		return orItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.IMPLIES} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IMPLIESItemProvider impliesItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.IMPLIES}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIMPLIESAdapter() {
		if (impliesItemProvider == null) {
			impliesItemProvider = new IMPLIESItemProvider(this);
		}

		return impliesItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.ExecutablePrimitiveTerm} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExecutablePrimitiveTermItemProvider executablePrimitiveTermItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.ExecutablePrimitiveTerm}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createExecutablePrimitiveTermAdapter() {
		if (executablePrimitiveTermItemProvider == null) {
			executablePrimitiveTermItemProvider = new ExecutablePrimitiveTermItemProvider(this);
		}

		return executablePrimitiveTermItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.AND_} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AND_ItemProvider anD_ItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.AND_}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAND_Adapter() {
		if (anD_ItemProvider == null) {
			anD_ItemProvider = new AND_ItemProvider(this);
		}

		return anD_ItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link cvl.ResolutionValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ResolutionValueItemProvider resolutionValueItemProvider;

	/**
	 * This creates an adapter for a {@link cvl.ResolutionValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createResolutionValueAdapter() {
		if (resolutionValueItemProvider == null) {
			resolutionValueItemProvider = new ResolutionValueItemProvider(this);
		}

		return resolutionValueItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (cvlModelItemProvider != null) cvlModelItemProvider.dispose();
		if (referenceSubstitutionItemProvider != null) referenceSubstitutionItemProvider.dispose();
		if (valueSubstitutionItemProvider != null) valueSubstitutionItemProvider.dispose();
		if (fragmentSubstitutionItemProvider != null) fragmentSubstitutionItemProvider.dispose();
		if (placementFragmentItemProvider != null) placementFragmentItemProvider.dispose();
		if (replacementFragmentItemProvider != null) replacementFragmentItemProvider.dispose();
		if (fromPlacementItemProvider != null) fromPlacementItemProvider.dispose();
		if (toPlacementItemProvider != null) toPlacementItemProvider.dispose();
		if (toReplacementItemProvider != null) toReplacementItemProvider.dispose();
		if (fromReplacementItemProvider != null) fromReplacementItemProvider.dispose();
		if (cvlElementItemProvider != null) cvlElementItemProvider.dispose();
		if (toBindingItemProvider != null) toBindingItemProvider.dispose();
		if (fromBindingItemProvider != null) fromBindingItemProvider.dispose();
		if (compositeVariabilityItemProvider != null) compositeVariabilityItemProvider.dispose();
		if (placementValueItemProvider != null) placementValueItemProvider.dispose();
		if (placementObjectItemProvider != null) placementObjectItemProvider.dispose();
		if (replacementValueItemProvider != null) replacementValueItemProvider.dispose();
		if (replacementObjectItemProvider != null) replacementObjectItemProvider.dispose();
		if (resolutionElementItemProvider != null) resolutionElementItemProvider.dispose();
		if (typeItemProvider != null) typeItemProvider.dispose();
		if (invocationItemProvider != null) invocationItemProvider.dispose();
		if (iteratorResolutionItemProvider != null) iteratorResolutionItemProvider.dispose();
		if (iteratorItemProvider != null) iteratorItemProvider.dispose();
		if (replacementFragmentReferenceItemProvider != null) replacementFragmentReferenceItemProvider.dispose();
		if (assignmentItemProvider != null) assignmentItemProvider.dispose();
		if (constraintItemProvider != null) constraintItemProvider.dispose();
		if (notItemProvider != null) notItemProvider.dispose();
		if (orItemProvider != null) orItemProvider.dispose();
		if (impliesItemProvider != null) impliesItemProvider.dispose();
		if (executablePrimitiveTermItemProvider != null) executablePrimitiveTermItemProvider.dispose();
		if (anD_ItemProvider != null) anD_ItemProvider.dispose();
		if (resolutionValueItemProvider != null) resolutionValueItemProvider.dispose();
	}

}
