package cvl.action;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.FileEditorInput;

import cvl.runtime.CVLExecutionManager;

public class CVLEditorActionDelegate implements IEditorActionDelegate {

	private IEditorPart editor;
	public CVLExecutionManager execManager = new CVLExecutionManager();

	public void setActiveEditor(IAction action, IEditorPart targetEditor) {
		this.editor = targetEditor;
	}

	public void run(IAction action) {
		IFile file = ((FileEditorInput)editor.getEditorInput()).getFile();
		String fileName = file.getLocation().toOSString(); //get path and filename
		
		if (fileName.contains("_diagram")){  //if the method is invoked from the diagram editor
			fileName = fileName.substring(0, fileName.indexOf("_diagram"));
		}
		
		execManager.initializeCVLModelFromFile(fileName);
		
		//get output filename
		FileDialog fd = new FileDialog(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(), SWT.SAVE);
		if (execManager.isUseUML()){
			fd.setFilterExtensions(new String[]{"*.uml"});
		}else{
			if (execManager.representation.baseExt.length() > 0){
				fd.setFilterExtensions(new String[]{"*." + execManager.representation.baseExt});
			}
		}
		fd.setFileName("");
		fd.setOverwrite(false);
		String path = fd.open();
		
		
		execManager.executeCVLModelFromFile(path);
		
	}

	public void selectionChanged(IAction action, ISelection selection) {
	}

}
