package cvl.action;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.RefreshAction;

public class CVLTransformationAction extends CVLEditorActionDelegate{
	
	public void run(IAction action){
		super.run(action);
		
		if (execManager.representation.errorMsg.size() > 0){
			String msg = "";
	
			for (String s : execManager.representation.errorMsg) {
				msg += "* " + s;
			}
			
			MessageDialog.openError(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(),"CVL","The following errors were encountered:\n\n" + msg);
			
		}else{
			if (execManager.isSuccessful()){
				MessageDialog.openInformation(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(),"CVL","Resolved model generated successfully.");
			}
		}
	
		//refresh the workspace to get the files in sync
		RefreshAction ra = new RefreshAction(PlatformUI.getWorkbench().getActiveWorkbenchWindow());
		ra.refreshAll();
	}
	
}
