package cvl.emfEditor;

import java.util.ArrayList;
import java.util.Iterator;

import org.eclipse.emf.ecore.presentation.EcoreEditor;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.TreeSelection;
import org.eclipse.jface.viewers.TreeViewer;

import cvl.interop.ICVLEnabledEditor;

public class EMFEditor extends EcoreEditor implements ICVLEnabledEditor {
	
	EMFEditorLabelProvider labelProvider = null;
	
	@Override
	public void createPages() {
		
		super.createPages();
				
		TreeViewer viewer = (TreeViewer) getViewer();
		
		// Extend the label provider to support colors and fonts
		AdapterFactoryLabelProvider old = (AdapterFactoryLabelProvider)viewer.getLabelProvider();
		labelProvider = new EMFEditorLabelProvider(old);
		viewer.setLabelProvider(labelProvider);
		
		viewer.addSelectionChangedListener(new ISelectionChangedListener() {

			public void selectionChanged(SelectionChangedEvent event) {
				event.getSource();
			}
		});
	}
	

	@Override
	public void clearHighlighting() {
		if (labelProvider == null) return;
		labelProvider.clearHighlighting();
		getViewer().refresh();
	}

	@Override
	public void selectObjects(ArrayList<String> objects) {
		//TODO: Implement this
	}
	
	@Override
	public ArrayList<Object> getSelectedObjects() {
		ArrayList<Object> result = new ArrayList<Object>();
		if (getViewer().getSelection() != null && getViewer().getSelection() instanceof TreeSelection) {
			TreeSelection s = (TreeSelection)getViewer().getSelection();
			Iterator<Object> it = s.iterator();
			while(it.hasNext()) {
				result.add(it.next());
			}
		}
		return result;
	}

	@Override
	public void highlightObject(String id, int type) {
		if (labelProvider == null) return;
		labelProvider.highlightObject(id, type);
		getViewer().refresh();
	}
}
