/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package cvl.visitors;

import cvl.AND_;
import cvl.Assignment;
import cvl.CVLElement;
import cvl.CVLModel;
import cvl.CompositeResolution;
import cvl.CompositeVariability;
import cvl.Constraint;
import cvl.ExecutablePrimitiveTerm;
import cvl.FragmentSubstitution;
import cvl.FromBinding;
import cvl.FromPlacement;
import cvl.FromReplacement;
import cvl.IMPLIES;
import cvl.Invocation;
import cvl.Iterator;
import cvl.IteratorResolution;
import cvl.NOT;
import cvl.OR;
import cvl.PlacementFragment;
import cvl.PlacementObject;
import cvl.PlacementValue;
import cvl.ReferenceSubstitution;
import cvl.ReplacementFragment;
import cvl.ReplacementFragmentBinding;
import cvl.ReplacementFragmentReference;
import cvl.ReplacementObject;
import cvl.ReplacementValue;
import cvl.ResolutionElement;
import cvl.ResolutionValue;
import cvl.ToBinding;
import cvl.ToPlacement;
import cvl.ToReplacement;
import cvl.Type;
import cvl.ValueSubstitution;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Visitor</b></em>'.
 * <!-- end-user-doc -->
 *
 *
 * @see cvl.visitors.VisitorsPackage#getVisitor()
 * @model interface="true" abstract="true"
 * @generated
 */
public interface Visitor<ContextType, ResultType> extends EObject {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitCVLModel(CVLModel node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitReferenceSubstitution(ReferenceSubstitution node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitValueSubstitution(ValueSubstitution node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitFragmentSubstitution(FragmentSubstitution node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitPlacementFragment(PlacementFragment node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitReplacementFragment(ReplacementFragment node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitFromPlacement(FromPlacement node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitToPlacement(ToPlacement node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitToReplacement(ToReplacement node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitFromReplacement(FromReplacement node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitCVLElement(CVLElement node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitToBinding(ToBinding node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitFromBinding(FromBinding node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitCompositeVariability(CompositeVariability node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitPlacementValue(PlacementValue node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitPlacementObject(PlacementObject node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitReplacementValue(ReplacementValue node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitReplacementObject(ReplacementObject node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitResolutionElement(ResolutionElement node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitType(Type node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitInvocation(Invocation node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitIteratorResolution(IteratorResolution node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitIterator(Iterator node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitReplacementFragmentReference(ReplacementFragmentReference node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitAssignment(Assignment node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitConstraint(Constraint node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitNOT(NOT node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitOR(OR node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitIMPLIES(IMPLIES node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitExecutablePrimitiveTerm(ExecutablePrimitiveTerm node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitAND_(AND_ node, ContextType context);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	ResultType visitResolutionValue(ResolutionValue node, ContextType context);

} // Visitor
