/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package cvl.visitors.impl;

import cvl.AND_;
import cvl.Assignment;
import cvl.CVLElement;
import cvl.CVLModel;
import cvl.CompositeResolution;
import cvl.CompositeVariability;
import cvl.Constraint;
import cvl.ExecutablePrimitiveTerm;
import cvl.FragmentSubstitution;
import cvl.FromBinding;
import cvl.FromPlacement;
import cvl.FromReplacement;
import cvl.IMPLIES;
import cvl.Invocation;
import cvl.Iterator;
import cvl.IteratorResolution;
import cvl.NOT;
import cvl.OR;
import cvl.PlacementFragment;
import cvl.PlacementObject;
import cvl.PlacementValue;
import cvl.ReferenceSubstitution;
import cvl.ReplacementFragment;
import cvl.ReplacementFragmentBinding;
import cvl.ReplacementFragmentReference;
import cvl.ReplacementObject;
import cvl.ReplacementValue;
import cvl.ResolutionElement;
import cvl.ResolutionValue;
import cvl.ToBinding;
import cvl.ToPlacement;
import cvl.ToReplacement;
import cvl.Type;
import cvl.ValueSubstitution;

import cvl.visitors.TopDownVisitor;
import cvl.visitors.VisitorsPackage;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.EObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Top Down Visitor</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public abstract class TopDownVisitorImpl<ContextType, ResultType> extends EObjectImpl implements TopDownVisitor<ContextType, ResultType> {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TopDownVisitorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return VisitorsPackage.Literals.TOP_DOWN_VISITOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitCVLModel(CVLModel node, ContextType context) {
		if (node.getVariabilitySpecification() != null) { node.getVariabilitySpecification().accept(this, context); }
		for (int i=0; i<node.getResolutionSpecification().size(); i++) { ((cvl.ResolutionSpecification)node.getResolutionSpecification().get(i)).accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitReferenceSubstitution(ReferenceSubstitution node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitValueSubstitution(ValueSubstitution node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitFragmentSubstitution(FragmentSubstitution node, ContextType context) {
		for (int i=0; i<node.getBoundaryElementBinding().size(); i++) { ((cvl.BoundaryElementBinding)node.getBoundaryElementBinding().get(i)).accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitPlacementFragment(PlacementFragment node, ContextType context) {
		for (int i=0; i<node.getBoundaryElement().size(); i++) { ((cvl.PlacementBoundaryElement)node.getBoundaryElement().get(i)).accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public ResultType visitReplacementFragment(ReplacementFragment node, ContextType context) {
		for (int i=0; i<node.getBoundaryElement().size(); i++) { ((cvl.ReplacementBoundaryElement)node.getBoundaryElement().get(i)).accept(this, context); }
	//	for (int i=0; i<node.getPlacements().size(); i++) { ((cvl.PlacementLiteral)node.getPlacements().get(i)).accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitFromPlacement(FromPlacement node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitToPlacement(ToPlacement node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitToReplacement(ToReplacement node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitFromReplacement(FromReplacement node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitCVLElement(CVLElement node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitToBinding(ToBinding node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitFromBinding(FromBinding node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitCompositeVariability(CompositeVariability node, ContextType context) {
		for (int i=0; i<node.getVariabilitySpecification().size(); i++) { ((cvl.VariabilitySpecification)node.getVariabilitySpecification().get(i)).accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitPlacementValue(PlacementValue node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitPlacementObject(PlacementObject node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitReplacementValue(ReplacementValue node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitReplacementObject(ReplacementObject node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitResolutionElement(ResolutionElement node, ContextType context) {
		for (int i=0; i<node.getResolution().size(); i++) { ((cvl.IteratorResolution)node.getResolution().get(i)).accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitType(Type node, ContextType context) {
		if (node.getBody() != null) { node.getBody().accept(this, context); }
		if (node.getReplacement() != null) { node.getReplacement().accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitInvocation(Invocation node, ContextType context) {
		if (node.getResolutionSpecification() != null) { node.getResolutionSpecification().accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitIteratorResolution(IteratorResolution node, ContextType context) {
		for (int i=0; i<node.getChoice().size(); i++) { ((cvl.ResolutionElement)node.getChoice().get(i)).accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitIterator(Iterator node, ContextType context) {
		for (int i=0; i<node.getVariabilitySpecification().size(); i++) { ((cvl.VariabilitySpecification)node.getVariabilitySpecification().get(i)).accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitReplacementFragmentReference(ReplacementFragmentReference node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitAssignment(Assignment node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitConstraint(Constraint node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitNOT(NOT node, ContextType context) {
		if (node.getTerm() != null) { node.getTerm().accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitOR(OR node, ContextType context) {
		if (node.getLeft() != null) { node.getLeft().accept(this, context); }
		if (node.getRight() != null) { node.getRight().accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitIMPLIES(IMPLIES node, ContextType context) {
		if (node.getLeft() != null) { node.getLeft().accept(this, context); }
		if (node.getRight() != null) { node.getRight().accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitExecutablePrimitiveTerm(ExecutablePrimitiveTerm node, ContextType context) {
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitAND_(AND_ node, ContextType context) {
		if (node.getLeft() != null) { node.getLeft().accept(this, context); }
		if (node.getRight() != null) { node.getRight().accept(this, context); }
		return null;
		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResultType visitResolutionValue(ResolutionValue node, ContextType context) {
		for (int i=0; i<node.getResolution().size(); i++) { ((cvl.IteratorResolution)node.getResolution().get(i)).accept(this, context); }
		return null;
		
	}

} //TopDownVisitorImpl
